#ifndef DRAWING_H
#define DRAWING_H
;
#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <SDL/SDL.h>
#include "polynome.h"

using namespace std;

typedef unsigned short int usint;

usint min(usint a,usint b);
usint max(usint a,usint b);
double absd(double d);
int approx(double d);

struct PointSDL{
  usint x,y;
};

struct PointR{
 Rationnel x,y;
};

struct Point{
 double x,y;
};

class Fenetre{
 public:
  double xmin,xmax,ymin,ymax;
  Fenetre(double xmin,double xmax,double ymin,double ymax);
};

struct Transformation{
  double xtrans,ytrans,rapport;
};

class Color{
 public:
  unsigned char red,green,blue;
  Color(unsigned char r,unsigned char g,unsigned char b);
  Color(unsigned char g);
};


class Screen{
 private:
  SDL_Surface *sdl_screen;
  Fenetre get_fenetre();
 public:
  Screen(int w,int h);
  ~Screen();
  void pause();
  void refresh();
  void draw_pixel(usint x,usint y,Color c);
  void draw_line(PointSDL A,PointSDL B,Color c);
  void draw_polynome(Polynome P,Fenetre F,Color c);
};

Transformation get_transformation(Fenetre F,Fenetre G);
PointSDL transforme(Point P,Transformation T);



#endif
