#include "interpolation.h"


Polynome Interpolation_Lagrange(PointR* P, usint n){
  Polynome R;//0
  for(usint i=0;i<n;i++){
    Polynome L;//0
    L[0]=1;//1
    for(usint k=0;k<n;k++){
      if(k!=i){
	Polynome temp(1);//X
	temp[0]=-P[k].x;//X-P[k].x
	temp=temp/(P[i].x-P[k].x);
	L=L*temp;
      }
    }
    R=R+P[i].y*L;
    cout<<L<<","<<R<<endl;
  }
  return R;
}

Polynome Bernstein(usint n,usint k){
  if(n==0){
    Polynome P(0);//P=1
    return P;
  }
  if(k==0){
    Polynome P(1);//P=X
    P[0]=1;P[1]=-1;//P=1-X
    return P*Bernstein(n-1,k);
  }
  if(k==n){
    Polynome P(1);//P=X
    return P*Bernstein(n-1,k-1);
  }
  else{
    Polynome P(1);//P=X;
    Polynome Q(1);//Q=X;
    Q[0]=1;Q[1]=-1;//Q=1-X;
    return Q*Bernstein(n-1,k)+P*Bernstein(n-1,k-1);
  }
}
